function [vvalue, xstar, premium, pVn_pc_c] = Vn_fun(c, paraminput, N, n, pi_param)

Bn = Bn_fun(paraminput,N,n,pi_param);
Gn = Gn_fun(paraminput, N, n, pi_param);

psi = psi_fun(paraminput,pi_param);
theta = theta_fun(paraminput);
beta = beta_fun(paraminput);

paraminput.psi = psi;
paraminput.theta = theta;
paraminput.beta = beta;

gamma = gamma_fun(paraminput);
paraminput.gamma = gamma;

paraminput.Bn = Bn;
paraminput.Gn = Gn;

if n == N
    vvalue = repmat(c ./ (paraminput.rhat - paraminput.muhat), length(pi_param), 1);
    premium = repmat(paraminput.zeta, length(pi_param), 1);
    pVn_pc_c = zeros(length(pi_param), 1);
    xstar = nan(length(pi_param), 1);
else
    vvalue = nan(length(pi_param), 1);
    premium = nan(length(pi_param), 1);
    pVn_pc_c = nan(length(pi_param), 1);
    xstar = xstar_fun(paraminput, N, n, pi_param, c);
    paraminput_i = paraminput;
    for i = 1:length(pi_param)
        paraminput_i.gamma = paraminput.gamma(i);
        paraminput_i.psi = paraminput.psi(i);
        paraminput_i.Bn = paraminput.Bn(i);
        paraminput_i.Gn = paraminput.Gn(i);
        if c >= xstar(i)
            tmpsum_v = 0;
            tmpsum_premuium1 = 0;
            for j = n:(N-1)
                tmpsum_v = tmpsum_v + Fni_fun(paraminput_i, N, n, j, pi_param(i), xstar(i)).*log(c).^(j - n);
                tmpsum_premuium1 = tmpsum_premuium1 + (paraminput_i.gamma*log(c)^(j - n) + (j - n)).*Fni_fun(paraminput_i, N, n, j, pi_param(i), xstar(i));
            end
            vvalue(i) = c.^(paraminput_i.gamma).*tmpsum_v + paraminput_i.Bn.*c + paraminput_i.Gn;
            pVn_pc_c(i) = (paraminput_i.Bn.*c + c.^paraminput_i.gamma .* tmpsum_premuium1);
            premium(i) = paraminput_i.zeta * pVn_pc_c(i)./vvalue(i);
            
        else
            An = An_fun(paraminput_i, N, n, pi_param(i), xstar(i));
            vvalue(i) = An.*c.^(beta);
            premium(i) = paraminput_i.zeta*beta;
            pVn_pc_c = zeros(length(pi_param), 1);
        end
    end
end

end