function Vn_vec = Vn_vs_lambda()

lambda_vec = (0.3:0.05:4)';

Vn_vec = nan(size(lambda_vec));

paraminput = paramset();

c = 10;
K = 5;
n = 2;

for i = 1:length(lambda_vec)
    Vn_vec(i) = Vn_fun(c, paraminput, K, n, lambda_vec(i));
end

figure
set(gcf, 'Position', [10 10 1250 900]*0.6)
set(gcf, 'Color', 'w');
plot(lambda_vec, Vn_vec, 'LineWidth', 1.3)
xlabel('$\lambda$', 'Interpreter', 'latex')
ylabel('$V(\lambda)$', 'Interpreter', 'latex')
yticks(30:30:150)
box off
grid minor