function Vn_with_unc_sigma_u()

paraminput = paramset();

sigma_u_vec = (0.01:0.02:0.5);
Vn_with_unc_vec = nan(size(sigma_u_vec));
Vn_no_unc_vec = nan(size(sigma_u_vec));

u_hat = 1.4;
x_i = log(2)/u_hat;

K = 5;
n = 2;
c = 10;

for i = 1:length(sigma_u_vec)
    [Vn_with_unc_vec(i), lambda, Vn_no_unc_vec(i)] = Vn_fun_hat(c, paraminput, K, n, u_hat, sigma_u_vec(i), x_i);
end
    

figure
set(gcf, 'Position', [10 10 1250 900]*0.6)
set(gcf, 'Color', 'w');
hold on
plot(sigma_u_vec, Vn_with_unc_vec, 'LineWidth', 1.3)
plot(sigma_u_vec, Vn_no_unc_vec, '--', 'LineWidth', 1.2)
hold off
xlabel('$\sigma_{\hat{u}}$', 'Interpreter', 'latex')
ylabel('$\widehat{V}$ and $V$', 'Interpreter', 'latex')
title(['$\hat{u} = ' num2str(u_hat) ', \widehat{\lambda} = ' num2str(lambda) ', x = ' num2str(x_i,2) '$'],'Interpreter', 'latex')
legend({'Valuation with uncertainty', 'Valuation without uncertainty'}, 'Location', 'southwest', 'Interpreter', 'latex', 'Box', 'off')
box off
grid minor