function cox_est_mesh(T, m, u_param)

Tvec = (2:T)';
mvec = (5:m)';

rng('default')
X = rand(T, m);
lambda_array = exp(u_param*X);
N_array = poissrnd(lambda_array);
beta_std_array = nan(length(Tvec), length(mvec));
[m_array_all, T_array_all] = meshgrid(mvec, Tvec);
for i = 1:numel(beta_std_array)
    X_tmp = X(1:T_array_all(i), 1:m_array_all(i));
    Narray_tmp = N_array(1:T_array_all(i), 1:m_array_all(i));
    [~, ~, beta_std_array(i)] = cox_simulation_estimation_given_X_N(X_tmp, Narray_tmp, u_param);
end

figure
set(gcf, 'Position', [10 10 1250 900]*0.6)
set(gcf, 'Color', 'w');
mesh(T_array_all, m_array_all, beta_std_array, 'FaceColor', 'flat')
xlabel('$T$', 'Interpreter', 'latex')
ylabel('$m$', 'Interpreter', 'latex')
zlabel('$\sigma_{\hat{u}}$', 'Interpreter', 'latex')
title(['True $u = ' num2str(u_param) '$'], 'Interpreter', 'latex')
view([-145, 24])
set(gca, 'Projection','perspective', 'Box', 'off')
alpha 0.5
grid minor


