function rp_mid_u_uncadv_with_bas_mesh(nn, K, n)
paraminput = paramset();
u_hat = 1.4;
x_i = log(2)/u_hat;
c = 10;
PIN = 0.35;
fixBAS = 0.03;

a = 0.64;
bvec = [3, 2, 1];

% a_vec = linspace(0.1, 10, nn)';
b_vec = linspace(0.01, 0.9, nn)';
sigma_u_vec = linspace(0.01, 0.8, nn)';
paraminput.a = 1*c;

[b_array, sigma_u_array] = meshgrid(b_vec, sigma_u_vec);
rp_array = nan(size(b_array));
rp_no_unc_array = nan(size(b_array));
RD_array = nan(size(b_array));
bas_array = nan(size(b_array));

rp_array_all = nan(size(b_array,1), size(b_array,2), length(bvec) + 1);
RD_array_all = nan(size(b_array,1), size(b_array,2), length(bvec) + 1);
bas_array_all = nan(size(b_array,1), size(b_array,2), length(bvec) + 1);

for j = 1:length(bvec)+1
    for i = 1:numel(b_array)
        paraminput.b = b_array(i);
        unc_measure = sigma_u_array(i);
        if j <= length(bvec)
            [rp_array(i), ~, V_i] = rp_mid_u_uncadv(c, paraminput, K, n, u_hat, x_i, unc_measure, a, bvec(j));
        else
            [rp_array(i), ~, V_i] = rp_mid_u(c, paraminput, K, n, u_hat, x_i, unc_measure);
        end
        lambda = exp(u_hat*x_i);
        [~, rp_no_unc_array(i)] = rp_mid(c, paraminput, K, n, lambda, unc_measure);
        bas_array(i) = fixBAS + PIN * abs(Vn_fun(c, paraminput, K, n, exp((u_hat + unc_measure)*x_i) ) - Vn_fun(c, paraminput, K, n, exp((u_hat - unc_measure)*x_i) ) )/abs(V_i);
        RD_array(i) = (paraminput.a + paraminput.b*c)/abs(V_i);
    end
    rp_array_all(:,:,j) = rp_array;
    RD_array_all(:,:,j) = RD_array;
    bas_array_all(:,:,j) = bas_array;
end

linestylestrs = {'-', '--', '-.', ':'};
Colorarray = [[0 0.4470 0.7410]; [0.8500 0.3250 0.0980]; [0.9290 0.6940 0.1250]; [0.4940 0.1840 0.5560]];

figure
set(gcf, 'Position', [10 10 2250 1050]*0.55)
set(gcf, 'Color', 'w');
subplot(1,2,1)
hold on
for j = 1:length(bvec)+1
    mesh(abs(RD_array_all(:,:,j)), bas_array_all(:,:,j), abs(rp_array_all(:,:,j))*100, 'FaceColor', Colorarray(j,:), 'EdgeColor', 'none')
end
mesh(abs(RD_array), bas_array, abs(rp_no_unc_array)*100, 'FaceColor', [0.8,0.8,0.8], 'EdgeColor', 'none')
hold off
legend({['Uncertainty adversion $z$ = ' num2str(bvec(1))], ['Uncertainty adversion $z$ = ' num2str(bvec(2))],...
    ['Uncertainty adversion $z$ = ' num2str(bvec(3))], 'No uncertainty adversion', ...
    'Without uncertainty'}, 'Location', 'west', 'Interpreter', 'latex', 'Box', 'off', 'FontSize', 7)
xlabel('RDME', 'Interpreter', 'latex')
ylabel('Bid-ask spread', 'Interpreter', 'latex')
zlabel('R\&D risk premium (percent)', 'Interpreter', 'latex')
title(['$\hat{u} = ' num2str(u_hat) ', \widehat{\lambda} = ' num2str(exp(u_hat*x_i)) ', x = ' num2str(x_i,2) '$'],'Interpreter', 'latex')
view([-41, 17])
set(gca, 'Projection','perspective', 'Box', 'off')
alpha 0.6
grid minor

subplot(1,2,2)
hold on
for j = 1:length(bvec)+1
    rp_slope = (abs(rp_array_all(:,end, j)) - abs(rp_array_all(:,1,j)))./(abs(RD_array_all(:,end,j)) - abs(RD_array_all(:,1,j)))*1e+4;
    bas4plot = linspace(bas_array_all(1,1,j), bas_array_all(end,1,j), nn*10);
    rp_slope4plot = interp1(bas_array_all(:,1,j) , rp_slope, bas4plot, 'spline', 'extrap');
    plot(bas4plot, rp_slope4plot, linestylestrs{j}, 'Color', Colorarray(j,:), 'LineStyle', linestylestrs{j},  'LineWidth', 1.2);
end
legend({['Uncertainty adversion $z$ = ' num2str(bvec(1))], ['Uncertainty adversion $z$ = ' num2str(bvec(2))],...
    ['Uncertainty adversion $z$ = ' num2str(bvec(3))], 'No uncertainty adversion'}, 'Location', 'northwest', 'Interpreter', 'latex', 'Box', 'off')
xlabel('Bid-ask spread', 'Interpreter', 'latex')
ylabel('R\&D risk premium slope (basis points)', 'Interpreter', 'latex')
title(['$\hat{u} = ' num2str(u_hat) ', \widehat{\lambda} = ' num2str(exp(u_hat*x_i)) ', x = ' num2str(x_i,2) '$'],'Interpreter', 'latex')
box off
grid minor

sgtitle(['Stage $n = ' num2str(n) '$'], 'Interpreter', 'latex')