function [ portfolio_return,index ] = dousortind( var1,var2,n1,n2,ret,me,nyse )
% The function is used for getting portfolio returns by independent double
% sort. Inputs include 'nyse' means using NYSE breakpoints, vice versa.
% Inputs: var1 --- first sorting variable
%         var2 --- second sorting variable
%           n1 --- number of portsolios based on var1
%           n2 --- number of portsolios based on var2
%          ret --- individual stock returns
%         nyse --- NYSE stock index
% NOTE: If going to calculate equal-weighter return, note we should load me
% matrix which is filled with 1 before running the function.
index = zeros(size(ret));
% using nyse breakpoints
if nargin == 7
    indvar1 = aprts(var1,n1,nyse);
    indvar2 = aprts(var2,n2,nyse);
    for i = 1 : n1
        for j = 1 : n2
            index(indvar1 == i & indvar2 == j) = (i-1)*n2 + j;
        end
    end
end
% using all stocks
if nargin == 6
    indvar1 = aprts(var1,n1);
    indvar2 = aprts(var2,n2);
    for i = 1 : n1
        for j = 1 : n2
            index(indvar1 == i & indvar2 == j) = (i-1)*n2 + j;
        end
    end
end


nport = n1*n2;                  % number of portfolios
indextemp1 = zeros(size(ret));

for k = 1 : nport
    indextemp2 = indextemp1;
    indextemp2(index == k) = 1;
    pret(:,k) = portfolioret(ret,indextemp2,1,me);
end

portfolio_return = pret;
end

