clear;
load bas1
load RDME
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE
load AG
load OP
load IffVOL

%yearly update (end June) except for illiquidity and idiosyncratic volatility

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

AG = ConvertToMonthlyUpdate(AG);

OP = ConvertToMonthlyUpdate(OP);

FinFirms = ConvertToMonthlyUpdate(FinFirms);

exindex = ConvertToMonthlyUpdate(exindex);

ocsindex = ConvertToMonthlyUpdate(ocsindex);

NYSE = ConvertToMonthlyUpdate(NYSE);

%----------------- keep ordinary common stocks only -----------------%
bas1(ocsindex~=1) = nan;

IffVOL(ocsindex~=1) = nan;

RDME(ocsindex~=1) = nan;

me(ocsindex~=1) = nan;

bm(ocsindex~=1) = nan;

OP(ocsindex~=1) = nan;

AG(ocsindex~=1) = nan;

NYSE(ocsindex~=1) = nan;

ret(ocsindex~=1) = nan;

%----------------- drop financial firms -----------------%     	
bas1(FinFirms==1) = nan;

IffVOL(FinFirms==1) = nan;

RDME(FinFirms==1) = nan;

me(FinFirms==1) = nan;

bm(FinFirms==1) = nan;

OP(FinFirms==1) = nan;

AG(FinFirms==1) = nan;

NYSE(FinFirms==1) = nan;

ret(FinFirms==1) = nan;

%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%     	
bas1(exindex~=1) = nan;

IffVOL(exindex~=1) = nan;

RDME(exindex~=1) = nan;

me(exindex~=1) = nan;

bm(exindex~=1) = nan;

OP(exindex~=1) = nan;

AG(exindex~=1) = nan;

NYSE(exindex~=1) = nan;

ret(exindex~=1) = nan;

%---------- drop negative bm ----------%
bmind = bm<0;

bas1(bmind==1) = nan;

IffVOL(bmind==1) = nan;

RDME(bmind==1) = nan;

me(bmind==1) = nan;

bm(bmind==1) = nan;

OP(bmind==1) = nan;

AG(bmind==1) = nan;

NYSE(bmind==1) = nan;

ret(bmind==1) = nan;

%% set up for regressions
me = log(me);

bm = log(bm);

R1 = ret;

R122 = cumret(ret,12,1);

[bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL] = keepobsconst(bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL);

me_fmb = make_fmbwin(me);

bm_fmb = make_fmbwin(bm);

R1_fmb = make_fmbwin(R1);

R122_fmb = make_fmbwin(R122);

bas1_fmb = make_fmbwin(bas1);

RDME_fmb = make_fmbwin(RDME);

AG_fmb = make_fmbwin(AG);

OP_fmb = make_fmbwin(OP);

IffVOL_fmb = make_fmbwin(IffVOL);

baind = aprts(bas1_fmb,3);

RDME1 = nan(size(RDME_fmb));

RDME1(baind==1) = RDME_fmb(baind==1);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME1];

y = ret*100;

r1 = fmbregnwConst(y,x);

RDME2 = nan(size(RDME_fmb));

RDME2(baind==3) = RDME_fmb(baind==3);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME2];

y = ret*100;

r2 = fmbregnwConst(y,x);

hml = r2.beta - r1.beta;

i = ones(rows(hml),1);

for j= 1:cols(hml)

    res = nanols(hml(:,j),i);

    bhat(j) = res.beta;

    t(j) = olsnwt(i,hml(:,j));

end

resulta = [r1.bhat; r1.t; r2.bhat; r2.t; bhat; t];
%% subsample analysis
clearvars -except resulta

load bas1
load RDME
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE
load AG
load OP
load IffVOL

%yearly update (end June) except for illiquidity and idiosyncratic volatility

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

AG = ConvertToMonthlyUpdate(AG);

OP = ConvertToMonthlyUpdate(OP);

FinFirms = ConvertToMonthlyUpdate(FinFirms);

exindex = ConvertToMonthlyUpdate(exindex);

ocsindex = ConvertToMonthlyUpdate(ocsindex);

NYSE = ConvertToMonthlyUpdate(NYSE);

%----------------- keep ordinary common stocks only -----------------%
bas1(ocsindex~=1) = nan;

IffVOL(ocsindex~=1) = nan;

RDME(ocsindex~=1) = nan;

me(ocsindex~=1) = nan;

bm(ocsindex~=1) = nan;

OP(ocsindex~=1) = nan;

AG(ocsindex~=1) = nan;

NYSE(ocsindex~=1) = nan;

ret(ocsindex~=1) = nan;

%----------------- drop financial firms -----------------%     	
bas1(FinFirms==1) = nan;

IffVOL(FinFirms==1) = nan;

RDME(FinFirms==1) = nan;

me(FinFirms==1) = nan;

bm(FinFirms==1) = nan;

OP(FinFirms==1) = nan;

AG(FinFirms==1) = nan;

NYSE(FinFirms==1) = nan;

ret(FinFirms==1) = nan;

%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%     	
bas1(exindex~=1) = nan;

IffVOL(exindex~=1) = nan;

RDME(exindex~=1) = nan;

me(exindex~=1) = nan;

bm(exindex~=1) = nan;

OP(exindex~=1) = nan;

AG(exindex~=1) = nan;

NYSE(exindex~=1) = nan;

ret(exindex~=1) = nan;

%---------- drop negative bm ----------%
bmind = bm<0;

bas1(bmind==1) = nan;

IffVOL(bmind==1) = nan;

RDME(bmind==1) = nan;

me(bmind==1) = nan;

bm(bmind==1) = nan;

OP(bmind==1) = nan;

AG(bmind==1) = nan;

NYSE(bmind==1) = nan;

ret(bmind==1) = nan;
%---------- drop microcaps ----------%
meindex = aprts(me,5,NYSE);

bas1(meindex==1) = nan;

RDME(meindex==1) = nan;

ret(meindex==1) = nan;

me(meindex==1) = nan;

bm(meindex==1) = nan;

AG(meindex==1) = nan;

OP(meindex==1) = nan;

IffVOL(meindex==1) = nan;

NYSE(meindex==1) = nan;
%% set up for regressions

me = log(me);

bm = log(bm);

R1 = ret;

R122 = cumret(ret,12,1);

[bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL] = keepobsconst(bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL);

me_fmb = make_fmbwin(me);

bm_fmb = make_fmbwin(bm);

R1_fmb = make_fmbwin(R1);

R122_fmb = make_fmbwin(R122);

bas1_fmb = make_fmbwin(bas1);

RDME_fmb = make_fmbwin(RDME);

AG_fmb = make_fmbwin(AG);

OP_fmb = make_fmbwin(OP);

IffVOL_fmb = make_fmbwin(IffVOL);

baind = aprts(bas1_fmb,3);

RDME1 = nan(size(RDME_fmb));

RDME1(baind==1) = RDME_fmb(baind==1);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME1];

y = ret*100;

r1 = fmbregnwConst(y,x);

RDME2 = nan(size(RDME_fmb));

RDME2(baind==3) = RDME_fmb(baind==3);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME2];

y = ret*100;

r2 = fmbregnwConst(y,x);

hml = r2.beta - r1.beta;

i = ones(rows(hml),1);

for j= 1:cols(hml)

    res = nanols(hml(:,j),i);

    bhat(j) = res.beta;

    t(j) = olsnwt(i,hml(:,j));

end

resultb = [r1.bhat; r1.t; r2.bhat; r2.t; bhat; t];
