clear;
load bas1
load RDME
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE
load AG
load OP
load IffVOL
%yearly update (end June) except for illiquidity and idiosyncratic volatility

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

AG = ConvertToMonthlyUpdate(AG);

OP = ConvertToMonthlyUpdate(OP);

FinFirms = ConvertToMonthlyUpdate(FinFirms);

exindex = ConvertToMonthlyUpdate(exindex);

ocsindex = ConvertToMonthlyUpdate(ocsindex);

NYSE = ConvertToMonthlyUpdate(NYSE);

%----------------- keep ordinary common stocks only -----------------%
bas1(ocsindex~=1) = nan;

IffVOL(ocsindex~=1) = nan;

RDME(ocsindex~=1) = nan;

me(ocsindex~=1) = nan;

bm(ocsindex~=1) = nan;

OP(ocsindex~=1) = nan;

AG(ocsindex~=1) = nan;

NYSE(ocsindex~=1) = nan;

ret(ocsindex~=1) = nan;

%----------------- drop financial firms -----------------%     	
bas1(FinFirms==1) = nan;

IffVOL(FinFirms==1) = nan;

RDME(FinFirms==1) = nan;

me(FinFirms==1) = nan;

bm(FinFirms==1) = nan;

OP(FinFirms==1) = nan;

AG(FinFirms==1) = nan;

NYSE(FinFirms==1) = nan;

ret(FinFirms==1) = nan;

%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%     	
bas1(exindex~=1) = nan;

IffVOL(exindex~=1) = nan;

RDME(exindex~=1) = nan;

me(exindex~=1) = nan;

bm(exindex~=1) = nan;

OP(exindex~=1) = nan;

AG(exindex~=1) = nan;

NYSE(exindex~=1) = nan;

ret(exindex~=1) = nan;

%---------- drop negative bm ----------%
bmind = bm<0;

bas1(bmind==1) = nan;

IffVOL(bmind==1) = nan;

RDME(bmind==1) = nan;

me(bmind==1) = nan;

bm(bmind==1) = nan;

OP(bmind==1) = nan;

AG(bmind==1) = nan;

NYSE(bmind==1) = nan;

ret(bmind==1) = nan;

%% set up for regressions
me = log(me);

bm = log(bm);

R1 = ret;

R122 = cumret(ret,12,1);

[bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL] = keepobsconst(bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL);

baind = aprts(bas1,3);

baind = lag(baind,1,nan);

me_fmb = make_fmbwin(me);

bm_fmb = make_fmbwin(bm);

R1_fmb = make_fmbwin(R1);

R122_fmb = make_fmbwin(R122);

RDME_fmb = make_fmbwin(RDME);

AG_fmb = make_fmbwin(AG);

OP_fmb = make_fmbwin(OP);

IffVOL_fmb = make_fmbwin(IffVOL);

bas1lowdum = zeros(size(me));

bas1lowdum(baind==1) = 1;

bas1higdum = zeros(size(me));

bas1higdum(baind==3) = 1;

intlowrd = RDME_fmb.*bas1lowdum;

inthigrd = RDME_fmb.*bas1higdum;

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb];

y = ret*100;

r1 = fmbregnwConst(y,x);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb intlowrd bas1lowdum];

y = ret*100;

r2 = fmbregnwConst(y,x);

rdlow = r2.beta(:,9) + r2.beta(:,10);

i = ones(rows(rdlow),1);

res = nanols(rdlow,i);

bhatlow = res.beta;         % this is to calculate RD slope for low-illiq stocks

tlow = olsnwt(i,rdlow);    	% this is newey-west adjusted t-stat

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb inthigrd bas1higdum];
y = ret*100;

r3 = fmbregnwConst(y,x);

rdhigh = r3.beta(:,9) + r3.beta(:,10);

i = ones(rows(rdhigh),1);

res = nanols(rdhigh,i);

bhathigh = res.beta;

thigh = olsnwt(i,rdhigh);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb inthigrd intlowrd bas1higdum bas1lowdum];

y = ret*100;

r4 = fmbregnwConst(y,x);

resulta =[r1.bhat nan nan nan nan; r1.t nan nan nan nan;
    r2.bhat(1:9) nan r2.bhat(10) nan r2.bhat(11); r2.t(1:9) nan r2.t(10) nan r2.t(11);
    r3.bhat(1:10) nan r3.bhat(11) nan; r3.t(1:10) nan r3.t(11) nan;
    r4.bhat; r4.t];

resulta2 = [bhatlow bhathigh; tlow thigh];

resulta3 = nanmean(nanmean(RDME_fmb,2));

%% subsample analysis
clearvars -except resulta resulta2 resulta3

load bas1
load RDME
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE
load AG
load OP
load IffVOL

%yearly update (end June) except for illiquidity and idiosyncratic volatility

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

AG = ConvertToMonthlyUpdate(AG);

OP = ConvertToMonthlyUpdate(OP);

FinFirms = ConvertToMonthlyUpdate(FinFirms);

exindex = ConvertToMonthlyUpdate(exindex);

ocsindex = ConvertToMonthlyUpdate(ocsindex);

NYSE = ConvertToMonthlyUpdate(NYSE);

%----------------- keep ordinary common stocks only -----------------%
bas1(ocsindex~=1) = nan;

IffVOL(ocsindex~=1) = nan;

RDME(ocsindex~=1) = nan;

me(ocsindex~=1) = nan;

bm(ocsindex~=1) = nan;

OP(ocsindex~=1) = nan;

AG(ocsindex~=1) = nan;

NYSE(ocsindex~=1) = nan;

ret(ocsindex~=1) = nan;

%----------------- drop financial firms -----------------%     	
bas1(FinFirms==1) = nan;

IffVOL(FinFirms==1) = nan;

RDME(FinFirms==1) = nan;

me(FinFirms==1) = nan;

bm(FinFirms==1) = nan;

OP(FinFirms==1) = nan;

AG(FinFirms==1) = nan;

NYSE(FinFirms==1) = nan;

ret(FinFirms==1) = nan;

%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%     	
bas1(exindex~=1) = nan;

IffVOL(exindex~=1) = nan;

RDME(exindex~=1) = nan;

me(exindex~=1) = nan;

bm(exindex~=1) = nan;

OP(exindex~=1) = nan;

AG(exindex~=1) = nan;

NYSE(exindex~=1) = nan;

ret(exindex~=1) = nan;

%---------- drop negative bm ----------%
bmind = bm<0;

bas1(bmind==1) = nan;

IffVOL(bmind==1) = nan;

RDME(bmind==1) = nan;

me(bmind==1) = nan;

bm(bmind==1) = nan;

OP(bmind==1) = nan;

AG(bmind==1) = nan;

NYSE(bmind==1) = nan;

ret(bmind==1) = nan;
%---------- drop microcaps ----------%
meindex = aprts(me,5,NYSE);

bas1(meindex==1) = nan;

RDME(meindex==1) = nan;

ret(meindex==1) = nan;

me(meindex==1) = nan;

bm(meindex==1) = nan;

AG(meindex==1) = nan;

OP(meindex==1) = nan;

IffVOL(meindex==1) = nan;

NYSE(meindex==1) = nan;
%% set up for regressions
me = log(me);

bm = log(bm);

R1 = ret;

R122 = cumret(ret,12,1);

[bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL] = keepobsconst(bas1, RDME, R1, R122, me, bm, AG, OP, IffVOL);

me_fmb = make_fmbwin(me);

bm_fmb = make_fmbwin(bm);

R1_fmb = make_fmbwin(R1);

R122_fmb = make_fmbwin(R122);

bas1_fmb = make_fmbwin(bas1);

RDME_fmb = make_fmbwin(RDME);

AG_fmb = make_fmbwin(AG);

OP_fmb = make_fmbwin(OP);

IffVOL_fmb = make_fmbwin(IffVOL);

baind = aprts(bas1,3);

baind = lag(baind,1,nan);

bas1lowdum = zeros(size(me));

bas1lowdum(baind==1) = 1;

bas1higdum = zeros(size(me));

bas1higdum(baind==3) = 1;

intlowrd = RDME_fmb.*bas1lowdum;

inthigrd = RDME_fmb.*bas1higdum;

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb];

y = ret*100;

r1 = fmbregnwConst(y,x);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb intlowrd bas1lowdum];

y = ret*100;

r2 = fmbregnwConst(y,x);

rdlow = r2.beta(:,9) + r2.beta(:,10);

i = ones(rows(rdlow),1);

res = nanols(rdlow,i);

bhatlow = res.beta;

tlow = olsnwt(i,rdlow);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb inthigrd bas1higdum];

y = ret*100;

r3 = fmbregnwConst(y,x);

rdhigh = r3.beta(:,9) + r3.beta(:,10);

i = ones(rows(rdhigh),1);

res = nanols(rdhigh,i);

bhathigh = res.beta;

thigh = olsnwt(i,rdhigh);

x = [R1_fmb R122_fmb bm_fmb me_fmb AG_fmb OP_fmb IffVOL_fmb RDME_fmb inthigrd intlowrd bas1higdum bas1lowdum];

y = ret*100;

r4 = fmbregnwConst(y,x);

resultb =[r1.bhat nan nan nan nan; r1.t nan nan nan nan;
    r2.bhat(1:9) nan r2.bhat(10) nan r2.bhat(11); r2.t(1:9) nan r2.t(10) nan r2.t(11);
    r3.bhat(1:10) nan r3.bhat(11) nan; r3.t(1:10) nan r3.t(11) nan;
    r4.bhat; r4.t];

resultb2 = [bhatlow bhathigh; tlow thigh];

resultb3 = nanmean(nanmean(RDME_fmb,2));

