clear;
load bas1
load RDME
load HHI    % Hirfindahl index
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE

% yearly update (end June) except for illiquidity

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

HHI = ConvertToMonthlyUpdate(HHI);

%----------------- keep ordinary common stocks only -----------------%
ocsindextemp = ConvertToMonthlyUpdate(ocsindex);

HHI(ocsindextemp~=1) = nan;

bas1(ocsindextemp~=1) = nan;

RDME(ocsindextemp~=1) = nan;

ret(ocsindextemp~=1) = nan;

bm(ocsindextemp~=1) = nan;

me(ocsindextemp~=1) = nan;

exindex(ocsindextemp~=1) = nan;

FinFirms(ocsindextemp~=1) = nan;
%----------------- drop financial firms -----------------%
FinFirmstemp = ConvertToMonthlyUpdate(FinFirms);

HHI(FinFirmstemp==1) = nan; 

bas1(FinFirmstemp==1) = nan;   

RDME(FinFirmstemp==1) = nan;

ret(FinFirmstemp==1) = nan;

me(FinFirmstemp==1) = nan;

bm(FinFirmstemp==1) = nan;

exindex(FinFirmstemp==1) = nan;

NYSE(FinFirmstemp==1) = nan;
%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%
exindextemp = ConvertToMonthlyUpdate(exindex);

HHI(exindextemp~=1) = nan; 

bas1(exindextemp~=1) = nan;  

RDME(exindextemp~=1) = nan;

ret(exindextemp~=1) = nan;

me(exindextemp~=1) = nan;

bm(exindextemp~=1) = nan;

NYSE(exindextemp~=1) = nan;
%---------- drop negative bm ----------%
bmind = bm<0;

bmindtemp = ConvertToMonthlyUpdate(bmind);

bas1(bmindtemp==1) = nan; 

RDME(bmindtemp==1) = nan;

ret(bmindtemp==1) = nan;

me(bmindtemp==1) = nan;

bm(bmindtemp==1) = nan;

NYSE(bmindtemp==1) = nan;

HHIindex = aprts(HHI,2);

bas1(HHIindex~=1) = nan;

RDME(HHIindex~=1) = nan;
%% double sorts analysis
% VW portfolios
load ff

bas1RDMEpret = dousortind(bas1,RDME,3,3,ret,me);

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

a = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF3, report FF3-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml;

save factors factor1 factor2 factor3 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,3);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,3);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,3);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

b = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF4, report FF3+mom-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml; factor4 = mom;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

c = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF5, report FF5-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb5; factor3 = hml; factor4 = rmw; factor5 = cma;

save factors factor1 factor2 factor3 factor4 factor5 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,5);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,5);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,5);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

d = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% HXZ, report HXZ-adjusted-abnormal-return, alpha
factor1 = hxzmkt; factor2 = hxzme; factor3 = hxzioa; factor4 = hxzroe;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

e = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% char-adjusted return
load DGTWret

bas1RDMEpret = dousortind(bas1,RDME,3,3,DGTWret,me);

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

f = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% ind-adjusted return
load indret

bas1RDMEpret = dousortind(bas1,RDME,3,3,indret,me);

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

g = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];

resulta =[a;f;g;b;c;d;e];

clearvars -except resulta

load bas1
load RDME
load HHI
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE

% yearly update (end June) except for illiquidity

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

HHI = ConvertToMonthlyUpdate(HHI);

%----------------- keep ordinary common stocks only -----------------%
ocsindextemp = ConvertToMonthlyUpdate(ocsindex);

HHI(ocsindextemp~=1) = nan;

bas1(ocsindextemp~=1) = nan;

RDME(ocsindextemp~=1) = nan;

ret(ocsindextemp~=1) = nan;

bm(ocsindextemp~=1) = nan;

me(ocsindextemp~=1) = nan;

exindex(ocsindextemp~=1) = nan;

FinFirms(ocsindextemp~=1) = nan;
%----------------- drop financial firms -----------------%
FinFirmstemp = ConvertToMonthlyUpdate(FinFirms);

HHI(FinFirmstemp==1) = nan; 

bas1(FinFirmstemp==1) = nan;   

RDME(FinFirmstemp==1) = nan;

ret(FinFirmstemp==1) = nan;

me(FinFirmstemp==1) = nan;

bm(FinFirmstemp==1) = nan;

exindex(FinFirmstemp==1) = nan;

NYSE(FinFirmstemp==1) = nan;
%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%
exindextemp = ConvertToMonthlyUpdate(exindex);

HHI(exindextemp~=1) = nan; 

bas1(exindextemp~=1) = nan;  

RDME(exindextemp~=1) = nan;

ret(exindextemp~=1) = nan;

me(exindextemp~=1) = nan;

bm(exindextemp~=1) = nan;

NYSE(exindextemp~=1) = nan;
%---------- drop negative bm ----------%
bmind = bm<0;

bmindtemp = ConvertToMonthlyUpdate(bmind);

bas1(bmindtemp==1) = nan; 

RDME(bmindtemp==1) = nan;

ret(bmindtemp==1) = nan;

me(bmindtemp==1) = nan;

bm(bmindtemp==1) = nan;

NYSE(bmindtemp==1) = nan;

HHIindex = aprts(HHI,2);

bas1(HHIindex~=2) = nan;

RDME(HHIindex~=2) = nan;
%% double sorts analysis
% VW portfolios
load ff

bas1RDMEpret = dousortind(bas1,RDME,3,3,ret,me);

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

a = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF3, report FF3-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml;

save factors factor1 factor2 factor3 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,3);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,3);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,3);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

b = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF4, report FF3+mom-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml; factor4 = mom;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

c = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF5, report FF5-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb5; factor3 = hml; factor4 = rmw; factor5 = cma;

save factors factor1 factor2 factor3 factor4 factor5 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,5);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,5);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,5);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

d = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% HXZ, report HXZ-adjusted-abnormal-return, alpha
factor1 = hxzmkt; factor2 = hxzme; factor3 = hxzioa; factor4 = hxzroe;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

e = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% char-adjusted return
load DGTWret

bas1RDMEpret = dousortind(bas1,RDME,3,3,DGTWret,me);

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

f = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% ind-adjusted return
load indret

bas1RDMEpret = dousortind(bas1,RDME,3,3,indret,me);

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

g = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];

resultb =[a;f;g;b;c;d;e];
%% subsample analysis
clearvars -except resulta resultb

load bas1
load RDME
load HHI
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE

% yearly update (end June) except for illiquidity

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

HHI = ConvertToMonthlyUpdate(HHI);

%----------------- keep ordinary common stocks only -----------------%
ocsindextemp = ConvertToMonthlyUpdate(ocsindex);

HHI(ocsindextemp~=1) = nan;

bas1(ocsindextemp~=1) = nan;

RDME(ocsindextemp~=1) = nan;

ret(ocsindextemp~=1) = nan;

bm(ocsindextemp~=1) = nan;

me(ocsindextemp~=1) = nan;

exindex(ocsindextemp~=1) = nan;

FinFirms(ocsindextemp~=1) = nan;
%----------------- drop financial firms -----------------%
FinFirmstemp = ConvertToMonthlyUpdate(FinFirms);

HHI(FinFirmstemp==1) = nan; 

bas1(FinFirmstemp==1) = nan;   

RDME(FinFirmstemp==1) = nan;

ret(FinFirmstemp==1) = nan;

me(FinFirmstemp==1) = nan;

bm(FinFirmstemp==1) = nan;

exindex(FinFirmstemp==1) = nan;

NYSE(FinFirmstemp==1) = nan;
%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%
exindextemp = ConvertToMonthlyUpdate(exindex);

HHI(exindextemp~=1) = nan; 

bas1(exindextemp~=1) = nan;  

RDME(exindextemp~=1) = nan;

ret(exindextemp~=1) = nan;

me(exindextemp~=1) = nan;

bm(exindextemp~=1) = nan;

NYSE(exindextemp~=1) = nan;
%---------- drop negative bm ----------%
bmind = bm<0;

bmindtemp = ConvertToMonthlyUpdate(bmind);

bas1(bmindtemp==1) = nan; 

RDME(bmindtemp==1) = nan;

ret(bmindtemp==1) = nan;

me(bmindtemp==1) = nan;

bm(bmindtemp==1) = nan;

NYSE(bmindtemp==1) = nan;
%---------- drop microcaps ----------%
meindex = aprts(me,5,NYSE);

bas1(meindex==1) = nan;

RDME(meindex==1) = nan;

ret(meindex==1) = nan;

me(meindex==1) = nan;

bm(meindex==1) = nan;

NYSE(meindex==1) = nan;

HHIindex = aprts(HHI,2);

bas1(HHIindex~=1) = nan;

RDME(HHIindex~=1) = nan;
%% double sorts analysis
load ff

wme = ones(size(me));                                             % for equal weighted

bas1RDMEpret = dousortind(bas1,RDME,3,3,ret,wme);                 % average portfolio return

indextemp = sum(isfinite(bas1RDMEpret),2);

indextemp2 = find(indextemp~=9);

bas1RDMEpret(indextemp2,:) = nan;

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])'; 

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

a = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF3, report FF3-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml;

save factors factor1 factor2 factor3 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,3);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,3);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,3);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

b = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF4, report FF3+mom-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml; factor4 = mom;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

c = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF5, report FF5-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb5; factor3 = hml; factor4 = rmw; factor5 = cma;

save factors factor1 factor2 factor3 factor4 factor5 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,5);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,5);

rdbas1_2alpha = rdbas1_2.alpha(1:3)'; 

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,5);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

d = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% HXZ, report HXZ-adjusted-abnormal-return, alpha
factor1 = hxzmkt; factor2 = hxzme; factor3 = hxzioa; factor4 = hxzroe;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

e = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% char-adjusted return
% EW portfolios
load DGTWret

bas1RDMEpret = dousortind(bas1,RDME,3,3,DGTWret,wme);

indextemp = sum(isfinite(bas1RDMEpret),2);

indextemp2 = find(indextemp~=9);

bas1RDMEpret(indextemp2,:) = nan;

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

f = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% ind-adjusted return
load indret

bas1RDMEpret = dousortind(bas1,RDME,3,3,indret,wme);

indextemp = sum(isfinite(bas1RDMEpret),2);

indextemp2 = find(indextemp~=9);

bas1RDMEpret(indextemp2,:) = nan;

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

g = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];

resultc =[a;f;g;b;c;d;e];

clearvars -except resulta resultb resultc

load bas1
load RDME
load HHI
load bm
load me
load ret
load dates
load permno
load exindex
load FinFirms
load ocsindex
load NYSE

%yearly update (end June) except for illiquidity

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

HHI = ConvertToMonthlyUpdate(HHI);

%----------------- keep ordinary common stocks only -----------------%
ocsindextemp = ConvertToMonthlyUpdate(ocsindex);

HHI(ocsindextemp~=1) = nan;

bas1(ocsindextemp~=1) = nan;

RDME(ocsindextemp~=1) = nan;

ret(ocsindextemp~=1) = nan;

bm(ocsindextemp~=1) = nan;

me(ocsindextemp~=1) = nan;

exindex(ocsindextemp~=1) = nan;

FinFirms(ocsindextemp~=1) = nan;
%----------------- drop financial firms -----------------%
FinFirmstemp = ConvertToMonthlyUpdate(FinFirms);

HHI(FinFirmstemp==1) = nan; 

bas1(FinFirmstemp==1) = nan;   

RDME(FinFirmstemp==1) = nan;

ret(FinFirmstemp==1) = nan;

me(FinFirmstemp==1) = nan;

bm(FinFirmstemp==1) = nan;

exindex(FinFirmstemp==1) = nan;

NYSE(FinFirmstemp==1) = nan;
%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%
exindextemp = ConvertToMonthlyUpdate(exindex);

HHI(exindextemp~=1) = nan; 

bas1(exindextemp~=1) = nan;  

RDME(exindextemp~=1) = nan;

ret(exindextemp~=1) = nan;

me(exindextemp~=1) = nan;

bm(exindextemp~=1) = nan;

NYSE(exindextemp~=1) = nan;
%---------- drop negative bm ----------%
bmind = bm<0;

bmindtemp = ConvertToMonthlyUpdate(bmind);

bas1(bmindtemp==1) = nan; 

RDME(bmindtemp==1) = nan;

ret(bmindtemp==1) = nan;

me(bmindtemp==1) = nan;

bm(bmindtemp==1) = nan;

NYSE(bmindtemp==1) = nan;
%---------- drop microcaps ----------%
meindex = aprts(me,5,NYSE);

bas1(meindex==1) = nan;

RDME(meindex==1) = nan;

ret(meindex==1) = nan;

me(meindex==1) = nan;

bm(meindex==1) = nan;

NYSE(meindex==1) = nan;

HHIindex = aprts(HHI,2);

bas1(HHIindex~=2) = nan;

RDME(HHIindex~=2) = nan;
%% double sorts analysis
load ff

wme = ones(size(me));         % for equal weighted

bas1RDMEpret = dousortind(bas1,RDME,3,3,ret,wme);

indextemp = sum(isfinite(bas1RDMEpret),2);

indextemp2 = find(indextemp~=9);

bas1RDMEpret(indextemp2,:) = nan;

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])'; 

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

a = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF3, report FF3-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml;

save factors factor1 factor2 factor3 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,3);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,3);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,3);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

b = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF4, report FF3+mom-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb3; factor3 = hml; factor4 = mom;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

c = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% FF5, report FF5-adjusted-abnormal-return, alpha
factor1 = mkt; factor2 = smb5; factor3 = hml; factor4 = rmw; factor5 = cma;

save factors factor1 factor2 factor3 factor4 factor5 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,5);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,5);

rdbas1_2alpha = rdbas1_2.alpha(1:3)'; 

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,5);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

d = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% HXZ, report HXZ-adjusted-abnormal-return, alpha
factor1 = hxzmkt; factor2 = hxzme; factor3 = hxzioa; factor4 = hxzroe;

save factors factor1 factor2 factor3 factor4 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,4);

rdbas1_1alpha = reshape(rdbas1_1.alpha(1:9),[3 3])';

rdbas1_1alphat = reshape(rdbas1_1.talpha(1:9),[3 3])';

rdbas1_1alphat2 = reshape(rdbas1_1.nwtalpha(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,4);

rdbas1_2alpha = rdbas1_2.alpha(1:3)';

rdbas1_2alphat = rdbas1_2.talpha(1:3)';

rdbas1_2alphat2 = rdbas1_2.nwtalpha(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,4);

rdbas1_3alpha = rdbas1_3.alpha(1:3);

rdbas1_3alphat = rdbas1_3.talpha(1:3);

rdbas1_3alphat2 = rdbas1_3.nwtalpha(1:3);

res = [rdbas1_1alpha rdbas1_2alpha; rdbas1_3alpha nan];

rest = [rdbas1_1alphat rdbas1_2alphat; rdbas1_3alphat nan];

rest2 = [rdbas1_1alphat2 rdbas1_2alphat2; rdbas1_3alphat2 nan]; 

e = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% char-adjusted return
% EW portfolios
load DGTWret

bas1RDMEpret = dousortind(bas1,RDME,3,3,DGTWret,wme);

indextemp = sum(isfinite(bas1RDMEpret),2);

indextemp2 = find(indextemp~=9);

bas1RDMEpret(indextemp2,:) = nan;

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

f = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];
%% ind-adjusted return
load indret

bas1RDMEpret = dousortind(bas1,RDME,3,3,indret,wme);

indextemp = sum(isfinite(bas1RDMEpret),2);

indextemp2 = find(indextemp~=9);

bas1RDMEpret(indextemp2,:) = nan;

hmlbas1_1 = bas1RDMEpret(:,3) - bas1RDMEpret(:,1) + rf;

hmlbas1_2 = bas1RDMEpret(:,6) - bas1RDMEpret(:,4) + rf;

hmlbas1_3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,7) + rf;

hmlrd1 = bas1RDMEpret(:,7) - bas1RDMEpret(:,1) + rf;

hmlrd2 = bas1RDMEpret(:,8) - bas1RDMEpret(:,2) + rf;

hmlrd3 = bas1RDMEpret(:,9) - bas1RDMEpret(:,3) + rf;

bas1RDME1 = [bas1RDMEpret(:,1:9)];

bas1RDME2 = [hmlbas1_1 hmlbas1_2 hmlbas1_3];

bas1RDME3 = [hmlrd1 hmlrd2 hmlrd3];

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

rdbas1_1 = factorregnw(bas1RDME1,1);

rdbas1_1ret = reshape(rdbas1_1.xret(1:9),[3 3])';

rdbas1_1rett = reshape(rdbas1_1.txret(1:9),[3 3])';

rdbas1_1rett2 = reshape(rdbas1_1.nwtxret(1:9),[3 3])';

rdbas1_2 = factorregnw(bas1RDME2,1);

rdbas1_2ret = rdbas1_2.xret(1:3)';

rdbas1_2rett = rdbas1_2.txret(1:3)';

rdbas1_2rett2 = rdbas1_2.nwtxret(1:3)';

rdbas1_3 = factorregnw(bas1RDME3,1);

rdbas1_3ret = rdbas1_3.xret(1:3);

rdbas1_3rett = rdbas1_3.txret(1:3);

rdbas1_3rett2 = rdbas1_3.nwtxret(1:3);

res = [rdbas1_1ret rdbas1_2ret; rdbas1_3ret nan];

rest = [rdbas1_1rett rdbas1_2rett; rdbas1_3rett nan];

rest2 = [rdbas1_1rett2 rdbas1_2rett2; rdbas1_3rett2 nan]; 

g = [res(1,:); rest2(1,:); res(2,:); rest2(2,:); res(3,:); rest2(3,:); res(4,:); rest2(4,:)];

resultd =[a;f;g;b;c;d;e];