clear;
load me
load bm
load RDME
load bas1
load IffVOL
load AG
load OP
load FinFirms
load exindex
load ocsindex
load NYSE
load ret

% yearly update (end June) except for illiquidity and idiosyncratic volatility

me = ConvertToMonthlyUpdate(me);

bm = ConvertToMonthlyUpdate(bm);

RDME = ConvertToMonthlyUpdate(RDME);

AG = ConvertToMonthlyUpdate(AG);

OP = ConvertToMonthlyUpdate(OP);

FinFirms = ConvertToMonthlyUpdate(FinFirms);

exindex = ConvertToMonthlyUpdate(exindex);

ocsindex = ConvertToMonthlyUpdate(ocsindex);

NYSE = ConvertToMonthlyUpdate(NYSE);

%----------------- keep ordinary common stocks only -----------------%
bas1(ocsindex~=1) = nan;

IffVOL(ocsindex~=1) = nan;

RDME(ocsindex~=1) = nan;

me(ocsindex~=1) = nan;

bm(ocsindex~=1) = nan;

OP(ocsindex~=1) = nan;

AG(ocsindex~=1) = nan;

NYSE(ocsindex~=1) = nan;

ret(ocsindex~=1) = nan;

%----------------- drop financial firms -----------------%     	
bas1(FinFirms==1) = nan;

IffVOL(FinFirms==1) = nan;

RDME(FinFirms==1) = nan;

me(FinFirms==1) = nan;

bm(FinFirms==1) = nan;

OP(FinFirms==1) = nan;

AG(FinFirms==1) = nan;

NYSE(FinFirms==1) = nan;

ret(FinFirms==1) = nan;

%---------- keep stocks traded in NYSE, AMEX, and NASDAQ only ----------%     	
bas1(exindex~=1) = nan;

IffVOL(exindex~=1) = nan;

RDME(exindex~=1) = nan;

me(exindex~=1) = nan;

bm(exindex~=1) = nan;

OP(exindex~=1) = nan;

AG(exindex~=1) = nan;

NYSE(exindex~=1) = nan;

ret(exindex~=1) = nan;

%---------- drop negative bm ----------%
bmind = bm<0;

bas1(bmind==1) = nan;

IffVOL(bmind==1) = nan;

RDME(bmind==1) = nan;

me(bmind==1) = nan;

bm(bmind==1) = nan;

OP(bmind==1) = nan;

AG(bmind==1) = nan;

NYSE(bmind==1) = nan;

ret(bmind==1) = nan;

R1 = lag(ret,1,nan);

R122 = cumret(ret,12,1)-1;

[bas1, RDME] = keepobsconst(bas1, RDME);    % no missing bas1 and RDME
%% mean

meanbas1 = nanmean(nanmean(bas1,2));

meanRDME = nanmean(nanmean(RDME,2));

resmean = [meanbas1; meanRDME];
%% standard deviation

stdbas1 = nanmean(nanstd(bas1,1,2));

stdRDME = nanmean(nanstd(RDME,1,2));

resstd = [stdbas1; stdRDME];
%% minimum

minbas1 = nanmean(nanmin(bas1,[],2));

minRDME = nanmean(nanmin(RDME,[],2));

resmin = [minbas1; minRDME];
%% maximum

maxbas1 = nanmean(nanmax(bas1,[],2));

maxRDME = nanmean(nanmax(RDME,[],2));

resmax = [maxbas1; maxRDME];
%% percentiles

prcbas1 = nanmean(prctile(bas1,[5 25 50 75 95],2));

prcRDME = nanmean(prctile(RDME,[5 25 50 75 95],2));

resprc = [prcbas1; prcRDME];
%% no. of obs

nobas1 = nanmean(nansum(isfinite(bas1),2));

noRDME = nanmean(nansum(isfinite(RDME),2));

resno = [nobas1; noRDME];

panela = [resmean resstd resmin resprc resmax resno];
%% 3x1 portfolio chracteristics

RDindex = aprts(RDME,3);

bas1ch = portfolioret(bas1,RDindex,1);

mech = portfolioret(me,RDindex,1);

bmch = portfolioret(bm,RDindex,1);

R1ch = portfolioret(R1,RDindex,1);

R122ch = portfolioret(R122,RDindex,1);

AGch = portfolioret(AG,RDindex,1);

OPch = portfolioret(OP,RDindex,1);

IffVOLch = portfolioret(IffVOL,RDindex,1);

panelb = [nanmean(bas1ch)' nanmean(mech)' nanmean(bmch)' nanmean(R1ch)' nanmean(R122ch)'...
      nanmean(AGch)' nanmean(OPch)' nanmean(IffVOLch)'];

%% portfolio return 3x1

RDMEindex = aprts(RDME,3);

RDMEvwpr = portfolioret(ret,RDMEindex,1,me);

RDMEewpr = portfolioret(ret,RDMEindex,1);

load ff

load dates

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

resRDME_vw = factorregnw(RDMEvwpr,1);

resRDME_ew = factorregnw(RDMEewpr,1);

panelc = [resRDME_vw.xret; resRDME_vw.txret;...
          resRDME_ew.xret; resRDME_ew.txret];

%% portfolio return 5x1

RDMEindex = aprts(RDME,5);

RDMEvwpr = portfolioret(ret,RDMEindex,1,me);

RDMEewpr = portfolioret(ret,RDMEindex,1);

load ff

load dates

save datestemp dates

factor1 = mkt;

save factors factor1 rf ffdates

resRDME_vw = factorregnw(RDMEvwpr,1);

resRDME_ew = factorregnw(RDMEewpr,1);

paneld = [resRDME_vw.xret; resRDME_vw.txret;...
          resRDME_ew.xret; resRDME_ew.txret];
