function [m,ww] = wmean(x,w);
% The function is used for calculating value-weighted returns

warning off ; 

if min(size(x)==size(w))==0  
   
    error('the variable and the weight matrix must have the same size') ; 

end


ind = (isnan(w) | isnan(x));

x(ind) = nan ; 

w(ind) = nan ; 

M = nan_sum(w,2) ; 

m = nan_sum(x.*w,2) ./ M ; 

m(M==0) = nan ; 

ww = w ./ repmat(M,1,cols(w));

ww(isinf(ww))=0;  

ww(isnan(ww))=0;  

warning on; 

ww = sparse(ww); 
